﻿#pragma warning disable 1591
//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace DAL
{
	using System.Data.Linq;
	using System.Data.Linq.Mapping;
	using System.Data;
	using System.Collections.Generic;
	using System.Reflection;
	using System.Linq;
	using System.Linq.Expressions;
	using System.ComponentModel;
	using System;
	
	
	[global::System.Data.Linq.Mapping.DatabaseAttribute(Name="1607_hisssappdb")]
	public partial class HisssAppDBDataContext : System.Data.Linq.DataContext
	{
		
		private static System.Data.Linq.Mapping.MappingSource mappingSource = new AttributeMappingSource();
		
    #region Extensibility Method Definitions
    partial void OnCreated();
    partial void InserttblAdmin(tblAdmin instance);
    partial void UpdatetblAdmin(tblAdmin instance);
    partial void DeletetblAdmin(tblAdmin instance);
    partial void InserttblBrand(tblBrand instance);
    partial void UpdatetblBrand(tblBrand instance);
    partial void DeletetblBrand(tblBrand instance);
    partial void InserttblGender(tblGender instance);
    partial void UpdatetblGender(tblGender instance);
    partial void DeletetblGender(tblGender instance);
    partial void InserttblProduct_Category(tblProduct_Category instance);
    partial void UpdatetblProduct_Category(tblProduct_Category instance);
    partial void DeletetblProduct_Category(tblProduct_Category instance);
    partial void InserttblProduct_price(tblProduct_price instance);
    partial void UpdatetblProduct_price(tblProduct_price instance);
    partial void DeletetblProduct_price(tblProduct_price instance);
    partial void InserttblProduct_SubCategory(tblProduct_SubCategory instance);
    partial void UpdatetblProduct_SubCategory(tblProduct_SubCategory instance);
    partial void DeletetblProduct_SubCategory(tblProduct_SubCategory instance);
    partial void InserttblProducts_Gender(tblProducts_Gender instance);
    partial void UpdatetblProducts_Gender(tblProducts_Gender instance);
    partial void DeletetblProducts_Gender(tblProducts_Gender instance);
    partial void InserttblUser(tblUser instance);
    partial void UpdatetblUser(tblUser instance);
    partial void DeletetblUser(tblUser instance);
    partial void InserttblUser_Device(tblUser_Device instance);
    partial void UpdatetblUser_Device(tblUser_Device instance);
    partial void DeletetblUser_Device(tblUser_Device instance);
    partial void InserttblProduct(tblProduct instance);
    partial void UpdatetblProduct(tblProduct instance);
    partial void DeletetblProduct(tblProduct instance);
    #endregion
		
		public HisssAppDBDataContext() : 
				base(global::DAL.Properties.Settings.Default._1607_hisssappdbConnectionString, mappingSource)
		{
			OnCreated();
		}
		
		public HisssAppDBDataContext(string connection) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public HisssAppDBDataContext(System.Data.IDbConnection connection) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public HisssAppDBDataContext(string connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public HisssAppDBDataContext(System.Data.IDbConnection connection, System.Data.Linq.Mapping.MappingSource mappingSource) : 
				base(connection, mappingSource)
		{
			OnCreated();
		}
		
		public System.Data.Linq.Table<tblAdmin> tblAdmins
		{
			get
			{
				return this.GetTable<tblAdmin>();
			}
		}
		
		public System.Data.Linq.Table<tblBrand> tblBrands
		{
			get
			{
				return this.GetTable<tblBrand>();
			}
		}
		
		public System.Data.Linq.Table<tblGender> tblGenders
		{
			get
			{
				return this.GetTable<tblGender>();
			}
		}
		
		public System.Data.Linq.Table<tblProduct_Category> tblProduct_Categories
		{
			get
			{
				return this.GetTable<tblProduct_Category>();
			}
		}
		
		public System.Data.Linq.Table<tblProduct_price> tblProduct_prices
		{
			get
			{
				return this.GetTable<tblProduct_price>();
			}
		}
		
		public System.Data.Linq.Table<tblProduct_SubCategory> tblProduct_SubCategories
		{
			get
			{
				return this.GetTable<tblProduct_SubCategory>();
			}
		}
		
		public System.Data.Linq.Table<tblProducts_Gender> tblProducts_Genders
		{
			get
			{
				return this.GetTable<tblProducts_Gender>();
			}
		}
		
		public System.Data.Linq.Table<tblUser> tblUsers
		{
			get
			{
				return this.GetTable<tblUser>();
			}
		}
		
		public System.Data.Linq.Table<tblUser_Device> tblUser_Devices
		{
			get
			{
				return this.GetTable<tblUser_Device>();
			}
		}
		
		public System.Data.Linq.Table<vwBrandsByCat> vwBrandsByCats
		{
			get
			{
				return this.GetTable<vwBrandsByCat>();
			}
		}
		
		public System.Data.Linq.Table<wvSubCategory> wvSubCategories
		{
			get
			{
				return this.GetTable<wvSubCategory>();
			}
		}
		
		public System.Data.Linq.Table<vwProduct> vwProducts
		{
			get
			{
				return this.GetTable<vwProduct>();
			}
		}
		
		public System.Data.Linq.Table<vwProductsCat> vwProductsCats
		{
			get
			{
				return this.GetTable<vwProductsCat>();
			}
		}
		
		public System.Data.Linq.Table<tblProduct> tblProducts
		{
			get
			{
				return this.GetTable<tblProduct>();
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblAdmin")]
	public partial class tblAdmin : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ID;
		
		private string _Username;
		
		private string _Password;
		
		private short _Type;
		
		private short _IsActive;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(int value);
    partial void OnIDChanged();
    partial void OnUsernameChanging(string value);
    partial void OnUsernameChanged();
    partial void OnPasswordChanging(string value);
    partial void OnPasswordChanged();
    partial void OnTypeChanging(short value);
    partial void OnTypeChanged();
    partial void OnIsActiveChanging(short value);
    partial void OnIsActiveChanged();
    #endregion
		
		public tblAdmin()
		{
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="Int NOT NULL", IsPrimaryKey=true)]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Username", DbType="NVarChar(250) NOT NULL", CanBeNull=false)]
		public string Username
		{
			get
			{
				return this._Username;
			}
			set
			{
				if ((this._Username != value))
				{
					this.OnUsernameChanging(value);
					this.SendPropertyChanging();
					this._Username = value;
					this.SendPropertyChanged("Username");
					this.OnUsernameChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Password", DbType="NVarChar(100) NOT NULL", CanBeNull=false)]
		public string Password
		{
			get
			{
				return this._Password;
			}
			set
			{
				if ((this._Password != value))
				{
					this.OnPasswordChanging(value);
					this.SendPropertyChanging();
					this._Password = value;
					this.SendPropertyChanged("Password");
					this.OnPasswordChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Type", DbType="SmallInt NOT NULL")]
		public short Type
		{
			get
			{
				return this._Type;
			}
			set
			{
				if ((this._Type != value))
				{
					this.OnTypeChanging(value);
					this.SendPropertyChanging();
					this._Type = value;
					this.SendPropertyChanged("Type");
					this.OnTypeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IsActive", DbType="SmallInt NOT NULL")]
		public short IsActive
		{
			get
			{
				return this._IsActive;
			}
			set
			{
				if ((this._IsActive != value))
				{
					this.OnIsActiveChanging(value);
					this.SendPropertyChanging();
					this._IsActive = value;
					this.SendPropertyChanged("IsActive");
					this.OnIsActiveChanged();
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblBrands")]
	public partial class tblBrand : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ID;
		
		private string _BrandName_FA;
		
		private string _BrandName_EN;
		
		private string _BrandImage;
		
		private System.Nullable<int> _BrandPriority;
		
		private short _BrandIsActive;
		
		private EntitySet<tblProduct> _tblProducts;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(int value);
    partial void OnIDChanged();
    partial void OnBrandName_FAChanging(string value);
    partial void OnBrandName_FAChanged();
    partial void OnBrandName_ENChanging(string value);
    partial void OnBrandName_ENChanged();
    partial void OnBrandImageChanging(string value);
    partial void OnBrandImageChanged();
    partial void OnBrandPriorityChanging(System.Nullable<int> value);
    partial void OnBrandPriorityChanged();
    partial void OnBrandIsActiveChanging(short value);
    partial void OnBrandIsActiveChanged();
    #endregion
		
		public tblBrand()
		{
			this._tblProducts = new EntitySet<tblProduct>(new Action<tblProduct>(this.attach_tblProducts), new Action<tblProduct>(this.detach_tblProducts));
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandName_FA", DbType="NVarChar(400) NOT NULL", CanBeNull=false)]
		public string BrandName_FA
		{
			get
			{
				return this._BrandName_FA;
			}
			set
			{
				if ((this._BrandName_FA != value))
				{
					this.OnBrandName_FAChanging(value);
					this.SendPropertyChanging();
					this._BrandName_FA = value;
					this.SendPropertyChanged("BrandName_FA");
					this.OnBrandName_FAChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandName_EN", DbType="NVarChar(400) NOT NULL", CanBeNull=false)]
		public string BrandName_EN
		{
			get
			{
				return this._BrandName_EN;
			}
			set
			{
				if ((this._BrandName_EN != value))
				{
					this.OnBrandName_ENChanging(value);
					this.SendPropertyChanging();
					this._BrandName_EN = value;
					this.SendPropertyChanged("BrandName_EN");
					this.OnBrandName_ENChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandImage", DbType="NVarChar(400) NOT NULL", CanBeNull=false)]
		public string BrandImage
		{
			get
			{
				return this._BrandImage;
			}
			set
			{
				if ((this._BrandImage != value))
				{
					this.OnBrandImageChanging(value);
					this.SendPropertyChanging();
					this._BrandImage = value;
					this.SendPropertyChanged("BrandImage");
					this.OnBrandImageChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandPriority", DbType="Int")]
		public System.Nullable<int> BrandPriority
		{
			get
			{
				return this._BrandPriority;
			}
			set
			{
				if ((this._BrandPriority != value))
				{
					this.OnBrandPriorityChanging(value);
					this.SendPropertyChanging();
					this._BrandPriority = value;
					this.SendPropertyChanged("BrandPriority");
					this.OnBrandPriorityChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandIsActive", DbType="SmallInt NOT NULL")]
		public short BrandIsActive
		{
			get
			{
				return this._BrandIsActive;
			}
			set
			{
				if ((this._BrandIsActive != value))
				{
					this.OnBrandIsActiveChanging(value);
					this.SendPropertyChanging();
					this._BrandIsActive = value;
					this.SendPropertyChanged("BrandIsActive");
					this.OnBrandIsActiveChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblBrand_tblProduct", Storage="_tblProducts", ThisKey="ID", OtherKey="BrandID")]
		public EntitySet<tblProduct> tblProducts
		{
			get
			{
				return this._tblProducts;
			}
			set
			{
				this._tblProducts.Assign(value);
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_tblProducts(tblProduct entity)
		{
			this.SendPropertyChanging();
			entity.tblBrand = this;
		}
		
		private void detach_tblProducts(tblProduct entity)
		{
			this.SendPropertyChanging();
			entity.tblBrand = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblGenders")]
	public partial class tblGender : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ID;
		
		private string _GenderTitle;
		
		private EntitySet<tblProducts_Gender> _tblProducts_Genders;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(int value);
    partial void OnIDChanged();
    partial void OnGenderTitleChanging(string value);
    partial void OnGenderTitleChanged();
    #endregion
		
		public tblGender()
		{
			this._tblProducts_Genders = new EntitySet<tblProducts_Gender>(new Action<tblProducts_Gender>(this.attach_tblProducts_Genders), new Action<tblProducts_Gender>(this.detach_tblProducts_Genders));
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="Int NOT NULL", IsPrimaryKey=true)]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_GenderTitle", DbType="NVarChar(100)")]
		public string GenderTitle
		{
			get
			{
				return this._GenderTitle;
			}
			set
			{
				if ((this._GenderTitle != value))
				{
					this.OnGenderTitleChanging(value);
					this.SendPropertyChanging();
					this._GenderTitle = value;
					this.SendPropertyChanged("GenderTitle");
					this.OnGenderTitleChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblGender_tblProducts_Gender", Storage="_tblProducts_Genders", ThisKey="ID", OtherKey="GenderID")]
		public EntitySet<tblProducts_Gender> tblProducts_Genders
		{
			get
			{
				return this._tblProducts_Genders;
			}
			set
			{
				this._tblProducts_Genders.Assign(value);
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_tblProducts_Genders(tblProducts_Gender entity)
		{
			this.SendPropertyChanging();
			entity.tblGender = this;
		}
		
		private void detach_tblProducts_Genders(tblProducts_Gender entity)
		{
			this.SendPropertyChanging();
			entity.tblGender = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblProduct_Categories")]
	public partial class tblProduct_Category : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ID;
		
		private string _CategoryName_FA;
		
		private string _CategoryName_EN;
		
		private System.Nullable<int> _CategoryPriority;
		
		private System.Nullable<System.DateTime> _RegDate;
		
		private EntitySet<tblProduct_SubCategory> _tblProduct_SubCategories;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(int value);
    partial void OnIDChanged();
    partial void OnCategoryName_FAChanging(string value);
    partial void OnCategoryName_FAChanged();
    partial void OnCategoryName_ENChanging(string value);
    partial void OnCategoryName_ENChanged();
    partial void OnCategoryPriorityChanging(System.Nullable<int> value);
    partial void OnCategoryPriorityChanged();
    partial void OnRegDateChanging(System.Nullable<System.DateTime> value);
    partial void OnRegDateChanged();
    #endregion
		
		public tblProduct_Category()
		{
			this._tblProduct_SubCategories = new EntitySet<tblProduct_SubCategory>(new Action<tblProduct_SubCategory>(this.attach_tblProduct_SubCategories), new Action<tblProduct_SubCategory>(this.detach_tblProduct_SubCategories));
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryName_FA", DbType="NVarChar(200) NOT NULL", CanBeNull=false)]
		public string CategoryName_FA
		{
			get
			{
				return this._CategoryName_FA;
			}
			set
			{
				if ((this._CategoryName_FA != value))
				{
					this.OnCategoryName_FAChanging(value);
					this.SendPropertyChanging();
					this._CategoryName_FA = value;
					this.SendPropertyChanged("CategoryName_FA");
					this.OnCategoryName_FAChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryName_EN", DbType="NVarChar(200)")]
		public string CategoryName_EN
		{
			get
			{
				return this._CategoryName_EN;
			}
			set
			{
				if ((this._CategoryName_EN != value))
				{
					this.OnCategoryName_ENChanging(value);
					this.SendPropertyChanging();
					this._CategoryName_EN = value;
					this.SendPropertyChanged("CategoryName_EN");
					this.OnCategoryName_ENChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryPriority", DbType="Int")]
		public System.Nullable<int> CategoryPriority
		{
			get
			{
				return this._CategoryPriority;
			}
			set
			{
				if ((this._CategoryPriority != value))
				{
					this.OnCategoryPriorityChanging(value);
					this.SendPropertyChanging();
					this._CategoryPriority = value;
					this.SendPropertyChanged("CategoryPriority");
					this.OnCategoryPriorityChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this.OnRegDateChanging(value);
					this.SendPropertyChanging();
					this._RegDate = value;
					this.SendPropertyChanged("RegDate");
					this.OnRegDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_Category_tblProduct_SubCategory", Storage="_tblProduct_SubCategories", ThisKey="ID", OtherKey="CategoryID")]
		public EntitySet<tblProduct_SubCategory> tblProduct_SubCategories
		{
			get
			{
				return this._tblProduct_SubCategories;
			}
			set
			{
				this._tblProduct_SubCategories.Assign(value);
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_tblProduct_SubCategories(tblProduct_SubCategory entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct_Category = this;
		}
		
		private void detach_tblProduct_SubCategories(tblProduct_SubCategory entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct_Category = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblProduct_prices")]
	public partial class tblProduct_price : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private System.Guid _ID;
		
		private string _Price;
		
		private int _ProductID;
		
		private string _CashBack;
		
		private System.Nullable<int> _SalePercent;
		
		private string _LastPrice;
		
		private System.DateTime _RegDate;
		
		private EntityRef<tblProduct> _tblProduct;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(System.Guid value);
    partial void OnIDChanged();
    partial void OnPriceChanging(string value);
    partial void OnPriceChanged();
    partial void OnProductIDChanging(int value);
    partial void OnProductIDChanged();
    partial void OnCashBackChanging(string value);
    partial void OnCashBackChanged();
    partial void OnSalePercentChanging(System.Nullable<int> value);
    partial void OnSalePercentChanged();
    partial void OnLastPriceChanging(string value);
    partial void OnLastPriceChanged();
    partial void OnRegDateChanging(System.DateTime value);
    partial void OnRegDateChanged();
    #endregion
		
		public tblProduct_price()
		{
			this._tblProduct = default(EntityRef<tblProduct>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
		public System.Guid ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Price", DbType="NVarChar(50) NOT NULL", CanBeNull=false)]
		public string Price
		{
			get
			{
				return this._Price;
			}
			set
			{
				if ((this._Price != value))
				{
					this.OnPriceChanging(value);
					this.SendPropertyChanging();
					this._Price = value;
					this.SendPropertyChanged("Price");
					this.OnPriceChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductID", DbType="Int NOT NULL")]
		public int ProductID
		{
			get
			{
				return this._ProductID;
			}
			set
			{
				if ((this._ProductID != value))
				{
					if (this._tblProduct.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnProductIDChanging(value);
					this.SendPropertyChanging();
					this._ProductID = value;
					this.SendPropertyChanged("ProductID");
					this.OnProductIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CashBack", DbType="NVarChar(50)")]
		public string CashBack
		{
			get
			{
				return this._CashBack;
			}
			set
			{
				if ((this._CashBack != value))
				{
					this.OnCashBackChanging(value);
					this.SendPropertyChanging();
					this._CashBack = value;
					this.SendPropertyChanged("CashBack");
					this.OnCashBackChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SalePercent", DbType="Int")]
		public System.Nullable<int> SalePercent
		{
			get
			{
				return this._SalePercent;
			}
			set
			{
				if ((this._SalePercent != value))
				{
					this.OnSalePercentChanging(value);
					this.SendPropertyChanging();
					this._SalePercent = value;
					this.SendPropertyChanged("SalePercent");
					this.OnSalePercentChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_LastPrice", DbType="NVarChar(20) NOT NULL", CanBeNull=false)]
		public string LastPrice
		{
			get
			{
				return this._LastPrice;
			}
			set
			{
				if ((this._LastPrice != value))
				{
					this.OnLastPriceChanging(value);
					this.SendPropertyChanging();
					this._LastPrice = value;
					this.SendPropertyChanged("LastPrice");
					this.OnLastPriceChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime NOT NULL")]
		public System.DateTime RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this.OnRegDateChanging(value);
					this.SendPropertyChanging();
					this._RegDate = value;
					this.SendPropertyChanged("RegDate");
					this.OnRegDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_tblProduct_price", Storage="_tblProduct", ThisKey="ProductID", OtherKey="ID", IsForeignKey=true)]
		public tblProduct tblProduct
		{
			get
			{
				return this._tblProduct.Entity;
			}
			set
			{
				tblProduct previousValue = this._tblProduct.Entity;
				if (((previousValue != value) 
							|| (this._tblProduct.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblProduct.Entity = null;
						previousValue.tblProduct_prices.Remove(this);
					}
					this._tblProduct.Entity = value;
					if ((value != null))
					{
						value.tblProduct_prices.Add(this);
						this._ProductID = value.ID;
					}
					else
					{
						this._ProductID = default(int);
					}
					this.SendPropertyChanged("tblProduct");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblProduct_SubCategories")]
	public partial class tblProduct_SubCategory : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ID;
		
		private int _CategoryID;
		
		private string _SubCategoryName_FA;
		
		private string _SubCategoryName_EN;
		
		private System.Nullable<int> _SubCategoryPriority;
		
		private System.Nullable<System.DateTime> _RegDate;
		
		private EntitySet<tblProduct> _tblProducts;
		
		private EntityRef<tblProduct_Category> _tblProduct_Category;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(int value);
    partial void OnIDChanged();
    partial void OnCategoryIDChanging(int value);
    partial void OnCategoryIDChanged();
    partial void OnSubCategoryName_FAChanging(string value);
    partial void OnSubCategoryName_FAChanged();
    partial void OnSubCategoryName_ENChanging(string value);
    partial void OnSubCategoryName_ENChanged();
    partial void OnSubCategoryPriorityChanging(System.Nullable<int> value);
    partial void OnSubCategoryPriorityChanged();
    partial void OnRegDateChanging(System.Nullable<System.DateTime> value);
    partial void OnRegDateChanged();
    #endregion
		
		public tblProduct_SubCategory()
		{
			this._tblProducts = new EntitySet<tblProduct>(new Action<tblProduct>(this.attach_tblProducts), new Action<tblProduct>(this.detach_tblProducts));
			this._tblProduct_Category = default(EntityRef<tblProduct_Category>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryID", DbType="Int NOT NULL")]
		public int CategoryID
		{
			get
			{
				return this._CategoryID;
			}
			set
			{
				if ((this._CategoryID != value))
				{
					if (this._tblProduct_Category.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnCategoryIDChanging(value);
					this.SendPropertyChanging();
					this._CategoryID = value;
					this.SendPropertyChanged("CategoryID");
					this.OnCategoryIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryName_FA", DbType="NVarChar(200) NOT NULL", CanBeNull=false)]
		public string SubCategoryName_FA
		{
			get
			{
				return this._SubCategoryName_FA;
			}
			set
			{
				if ((this._SubCategoryName_FA != value))
				{
					this.OnSubCategoryName_FAChanging(value);
					this.SendPropertyChanging();
					this._SubCategoryName_FA = value;
					this.SendPropertyChanged("SubCategoryName_FA");
					this.OnSubCategoryName_FAChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryName_EN", DbType="NVarChar(200)")]
		public string SubCategoryName_EN
		{
			get
			{
				return this._SubCategoryName_EN;
			}
			set
			{
				if ((this._SubCategoryName_EN != value))
				{
					this.OnSubCategoryName_ENChanging(value);
					this.SendPropertyChanging();
					this._SubCategoryName_EN = value;
					this.SendPropertyChanged("SubCategoryName_EN");
					this.OnSubCategoryName_ENChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryPriority", DbType="Int")]
		public System.Nullable<int> SubCategoryPriority
		{
			get
			{
				return this._SubCategoryPriority;
			}
			set
			{
				if ((this._SubCategoryPriority != value))
				{
					this.OnSubCategoryPriorityChanging(value);
					this.SendPropertyChanging();
					this._SubCategoryPriority = value;
					this.SendPropertyChanged("SubCategoryPriority");
					this.OnSubCategoryPriorityChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this.OnRegDateChanging(value);
					this.SendPropertyChanging();
					this._RegDate = value;
					this.SendPropertyChanged("RegDate");
					this.OnRegDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_SubCategory_tblProduct", Storage="_tblProducts", ThisKey="ID", OtherKey="SubCategoryID")]
		public EntitySet<tblProduct> tblProducts
		{
			get
			{
				return this._tblProducts;
			}
			set
			{
				this._tblProducts.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_Category_tblProduct_SubCategory", Storage="_tblProduct_Category", ThisKey="CategoryID", OtherKey="ID", IsForeignKey=true)]
		public tblProduct_Category tblProduct_Category
		{
			get
			{
				return this._tblProduct_Category.Entity;
			}
			set
			{
				tblProduct_Category previousValue = this._tblProduct_Category.Entity;
				if (((previousValue != value) 
							|| (this._tblProduct_Category.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblProduct_Category.Entity = null;
						previousValue.tblProduct_SubCategories.Remove(this);
					}
					this._tblProduct_Category.Entity = value;
					if ((value != null))
					{
						value.tblProduct_SubCategories.Add(this);
						this._CategoryID = value.ID;
					}
					else
					{
						this._CategoryID = default(int);
					}
					this.SendPropertyChanged("tblProduct_Category");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_tblProducts(tblProduct entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct_SubCategory = this;
		}
		
		private void detach_tblProducts(tblProduct entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct_SubCategory = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblProducts_Genders")]
	public partial class tblProducts_Gender : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ProductID;
		
		private int _GenderID;
		
		private EntityRef<tblGender> _tblGender;
		
		private EntityRef<tblProduct> _tblProduct;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnProductIDChanging(int value);
    partial void OnProductIDChanged();
    partial void OnGenderIDChanging(int value);
    partial void OnGenderIDChanged();
    #endregion
		
		public tblProducts_Gender()
		{
			this._tblGender = default(EntityRef<tblGender>);
			this._tblProduct = default(EntityRef<tblProduct>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductID", DbType="Int NOT NULL", IsPrimaryKey=true)]
		public int ProductID
		{
			get
			{
				return this._ProductID;
			}
			set
			{
				if ((this._ProductID != value))
				{
					if (this._tblProduct.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnProductIDChanging(value);
					this.SendPropertyChanging();
					this._ProductID = value;
					this.SendPropertyChanged("ProductID");
					this.OnProductIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_GenderID", DbType="Int NOT NULL", IsPrimaryKey=true)]
		public int GenderID
		{
			get
			{
				return this._GenderID;
			}
			set
			{
				if ((this._GenderID != value))
				{
					if (this._tblGender.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnGenderIDChanging(value);
					this.SendPropertyChanging();
					this._GenderID = value;
					this.SendPropertyChanged("GenderID");
					this.OnGenderIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblGender_tblProducts_Gender", Storage="_tblGender", ThisKey="GenderID", OtherKey="ID", IsForeignKey=true)]
		public tblGender tblGender
		{
			get
			{
				return this._tblGender.Entity;
			}
			set
			{
				tblGender previousValue = this._tblGender.Entity;
				if (((previousValue != value) 
							|| (this._tblGender.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblGender.Entity = null;
						previousValue.tblProducts_Genders.Remove(this);
					}
					this._tblGender.Entity = value;
					if ((value != null))
					{
						value.tblProducts_Genders.Add(this);
						this._GenderID = value.ID;
					}
					else
					{
						this._GenderID = default(int);
					}
					this.SendPropertyChanged("tblGender");
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_tblProducts_Gender", Storage="_tblProduct", ThisKey="ProductID", OtherKey="ID", IsForeignKey=true)]
		public tblProduct tblProduct
		{
			get
			{
				return this._tblProduct.Entity;
			}
			set
			{
				tblProduct previousValue = this._tblProduct.Entity;
				if (((previousValue != value) 
							|| (this._tblProduct.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblProduct.Entity = null;
						previousValue.tblProducts_Genders.Remove(this);
					}
					this._tblProduct.Entity = value;
					if ((value != null))
					{
						value.tblProducts_Genders.Add(this);
						this._ProductID = value.ID;
					}
					else
					{
						this._ProductID = default(int);
					}
					this.SendPropertyChanged("tblProduct");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblUsers")]
	public partial class tblUser : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private System.Guid _ID;
		
		private string _Mobile;
		
		private string _Email;
		
		private string _ImageUrl;
		
		private string _FullName;
		
		private System.Nullable<bool> _Gender;
		
		private string _Birthday;
		
		private string _NationalCode;
		
		private string _Password;
		
		private System.Nullable<bool> _IsNewsletter;
		
		private System.Nullable<short> _MobileRegisterd;
		
		private string _RegCode;
		
		private System.Nullable<bool> _IsActive;
		
		private System.Nullable<System.DateTime> _LastLoginDate;
		
		private System.DateTime _RegDate;
		
		private EntitySet<tblUser_Device> _tblUser_Devices;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(System.Guid value);
    partial void OnIDChanged();
    partial void OnMobileChanging(string value);
    partial void OnMobileChanged();
    partial void OnEmailChanging(string value);
    partial void OnEmailChanged();
    partial void OnImageUrlChanging(string value);
    partial void OnImageUrlChanged();
    partial void OnFullNameChanging(string value);
    partial void OnFullNameChanged();
    partial void OnGenderChanging(System.Nullable<bool> value);
    partial void OnGenderChanged();
    partial void OnBirthdayChanging(string value);
    partial void OnBirthdayChanged();
    partial void OnNationalCodeChanging(string value);
    partial void OnNationalCodeChanged();
    partial void OnPasswordChanging(string value);
    partial void OnPasswordChanged();
    partial void OnIsNewsletterChanging(System.Nullable<bool> value);
    partial void OnIsNewsletterChanged();
    partial void OnMobileRegisterdChanging(System.Nullable<short> value);
    partial void OnMobileRegisterdChanged();
    partial void OnRegCodeChanging(string value);
    partial void OnRegCodeChanged();
    partial void OnIsActiveChanging(System.Nullable<bool> value);
    partial void OnIsActiveChanged();
    partial void OnLastLoginDateChanging(System.Nullable<System.DateTime> value);
    partial void OnLastLoginDateChanged();
    partial void OnRegDateChanging(System.DateTime value);
    partial void OnRegDateChanged();
    #endregion
		
		public tblUser()
		{
			this._tblUser_Devices = new EntitySet<tblUser_Device>(new Action<tblUser_Device>(this.attach_tblUser_Devices), new Action<tblUser_Device>(this.detach_tblUser_Devices));
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
		public System.Guid ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Mobile", DbType="NVarChar(20)")]
		public string Mobile
		{
			get
			{
				return this._Mobile;
			}
			set
			{
				if ((this._Mobile != value))
				{
					this.OnMobileChanging(value);
					this.SendPropertyChanging();
					this._Mobile = value;
					this.SendPropertyChanged("Mobile");
					this.OnMobileChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Email", DbType="NVarChar(200)")]
		public string Email
		{
			get
			{
				return this._Email;
			}
			set
			{
				if ((this._Email != value))
				{
					this.OnEmailChanging(value);
					this.SendPropertyChanging();
					this._Email = value;
					this.SendPropertyChanged("Email");
					this.OnEmailChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ImageUrl", DbType="NVarChar(200)")]
		public string ImageUrl
		{
			get
			{
				return this._ImageUrl;
			}
			set
			{
				if ((this._ImageUrl != value))
				{
					this.OnImageUrlChanging(value);
					this.SendPropertyChanging();
					this._ImageUrl = value;
					this.SendPropertyChanged("ImageUrl");
					this.OnImageUrlChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_FullName", DbType="NVarChar(200)")]
		public string FullName
		{
			get
			{
				return this._FullName;
			}
			set
			{
				if ((this._FullName != value))
				{
					this.OnFullNameChanging(value);
					this.SendPropertyChanging();
					this._FullName = value;
					this.SendPropertyChanged("FullName");
					this.OnFullNameChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Gender", DbType="Bit")]
		public System.Nullable<bool> Gender
		{
			get
			{
				return this._Gender;
			}
			set
			{
				if ((this._Gender != value))
				{
					this.OnGenderChanging(value);
					this.SendPropertyChanging();
					this._Gender = value;
					this.SendPropertyChanged("Gender");
					this.OnGenderChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Birthday", DbType="NVarChar(50)")]
		public string Birthday
		{
			get
			{
				return this._Birthday;
			}
			set
			{
				if ((this._Birthday != value))
				{
					this.OnBirthdayChanging(value);
					this.SendPropertyChanging();
					this._Birthday = value;
					this.SendPropertyChanged("Birthday");
					this.OnBirthdayChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_NationalCode", DbType="NVarChar(50)")]
		public string NationalCode
		{
			get
			{
				return this._NationalCode;
			}
			set
			{
				if ((this._NationalCode != value))
				{
					this.OnNationalCodeChanging(value);
					this.SendPropertyChanging();
					this._NationalCode = value;
					this.SendPropertyChanged("NationalCode");
					this.OnNationalCodeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Password", DbType="NVarChar(50)")]
		public string Password
		{
			get
			{
				return this._Password;
			}
			set
			{
				if ((this._Password != value))
				{
					this.OnPasswordChanging(value);
					this.SendPropertyChanging();
					this._Password = value;
					this.SendPropertyChanged("Password");
					this.OnPasswordChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IsNewsletter", DbType="Bit")]
		public System.Nullable<bool> IsNewsletter
		{
			get
			{
				return this._IsNewsletter;
			}
			set
			{
				if ((this._IsNewsletter != value))
				{
					this.OnIsNewsletterChanging(value);
					this.SendPropertyChanging();
					this._IsNewsletter = value;
					this.SendPropertyChanged("IsNewsletter");
					this.OnIsNewsletterChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_MobileRegisterd", DbType="SmallInt")]
		public System.Nullable<short> MobileRegisterd
		{
			get
			{
				return this._MobileRegisterd;
			}
			set
			{
				if ((this._MobileRegisterd != value))
				{
					this.OnMobileRegisterdChanging(value);
					this.SendPropertyChanging();
					this._MobileRegisterd = value;
					this.SendPropertyChanged("MobileRegisterd");
					this.OnMobileRegisterdChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegCode", DbType="NChar(10)")]
		public string RegCode
		{
			get
			{
				return this._RegCode;
			}
			set
			{
				if ((this._RegCode != value))
				{
					this.OnRegCodeChanging(value);
					this.SendPropertyChanging();
					this._RegCode = value;
					this.SendPropertyChanged("RegCode");
					this.OnRegCodeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_IsActive", DbType="Bit")]
		public System.Nullable<bool> IsActive
		{
			get
			{
				return this._IsActive;
			}
			set
			{
				if ((this._IsActive != value))
				{
					this.OnIsActiveChanging(value);
					this.SendPropertyChanging();
					this._IsActive = value;
					this.SendPropertyChanged("IsActive");
					this.OnIsActiveChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_LastLoginDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> LastLoginDate
		{
			get
			{
				return this._LastLoginDate;
			}
			set
			{
				if ((this._LastLoginDate != value))
				{
					this.OnLastLoginDateChanging(value);
					this.SendPropertyChanging();
					this._LastLoginDate = value;
					this.SendPropertyChanged("LastLoginDate");
					this.OnLastLoginDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime NOT NULL")]
		public System.DateTime RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this.OnRegDateChanging(value);
					this.SendPropertyChanging();
					this._RegDate = value;
					this.SendPropertyChanged("RegDate");
					this.OnRegDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblUser_tblUser_Device", Storage="_tblUser_Devices", ThisKey="ID", OtherKey="UserID")]
		public EntitySet<tblUser_Device> tblUser_Devices
		{
			get
			{
				return this._tblUser_Devices;
			}
			set
			{
				this._tblUser_Devices.Assign(value);
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_tblUser_Devices(tblUser_Device entity)
		{
			this.SendPropertyChanging();
			entity.tblUser = this;
		}
		
		private void detach_tblUser_Devices(tblUser_Device entity)
		{
			this.SendPropertyChanging();
			entity.tblUser = null;
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblUser_Devices")]
	public partial class tblUser_Device : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private System.Guid _ID;
		
		private System.Nullable<System.Guid> _UserID;
		
		private string _DeviceID;
		
		private int _DeviceTypeID;
		
		private string _DeviceNotifictionID;
		
		private string _DeviceIP;
		
		private string _DeviceBrand;
		
		private string _DeviceModel;
		
		private string _DeviceOsVersion;
		
		private string _DeviceScreenSize;
		
		private System.Nullable<int> _DeviceStatusID;
		
		private string _DeviceAppVersion;
		
		private System.DateTime _RegDate;
		
		private EntityRef<tblUser> _tblUser;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(System.Guid value);
    partial void OnIDChanged();
    partial void OnUserIDChanging(System.Nullable<System.Guid> value);
    partial void OnUserIDChanged();
    partial void OnDeviceIDChanging(string value);
    partial void OnDeviceIDChanged();
    partial void OnDeviceTypeIDChanging(int value);
    partial void OnDeviceTypeIDChanged();
    partial void OnDeviceNotifictionIDChanging(string value);
    partial void OnDeviceNotifictionIDChanged();
    partial void OnDeviceIPChanging(string value);
    partial void OnDeviceIPChanged();
    partial void OnDeviceBrandChanging(string value);
    partial void OnDeviceBrandChanged();
    partial void OnDeviceModelChanging(string value);
    partial void OnDeviceModelChanged();
    partial void OnDeviceOsVersionChanging(string value);
    partial void OnDeviceOsVersionChanged();
    partial void OnDeviceScreenSizeChanging(string value);
    partial void OnDeviceScreenSizeChanged();
    partial void OnDeviceStatusIDChanging(System.Nullable<int> value);
    partial void OnDeviceStatusIDChanged();
    partial void OnDeviceAppVersionChanging(string value);
    partial void OnDeviceAppVersionChanged();
    partial void OnRegDateChanging(System.DateTime value);
    partial void OnRegDateChanged();
    #endregion
		
		public tblUser_Device()
		{
			this._tblUser = default(EntityRef<tblUser>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
		public System.Guid ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserID", DbType="UniqueIdentifier")]
		public System.Nullable<System.Guid> UserID
		{
			get
			{
				return this._UserID;
			}
			set
			{
				if ((this._UserID != value))
				{
					if (this._tblUser.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnUserIDChanging(value);
					this.SendPropertyChanging();
					this._UserID = value;
					this.SendPropertyChanged("UserID");
					this.OnUserIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceID", DbType="NVarChar(250) NOT NULL", CanBeNull=false)]
		public string DeviceID
		{
			get
			{
				return this._DeviceID;
			}
			set
			{
				if ((this._DeviceID != value))
				{
					this.OnDeviceIDChanging(value);
					this.SendPropertyChanging();
					this._DeviceID = value;
					this.SendPropertyChanged("DeviceID");
					this.OnDeviceIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceTypeID", DbType="Int NOT NULL")]
		public int DeviceTypeID
		{
			get
			{
				return this._DeviceTypeID;
			}
			set
			{
				if ((this._DeviceTypeID != value))
				{
					this.OnDeviceTypeIDChanging(value);
					this.SendPropertyChanging();
					this._DeviceTypeID = value;
					this.SendPropertyChanged("DeviceTypeID");
					this.OnDeviceTypeIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceNotifictionID", DbType="NVarChar(200)")]
		public string DeviceNotifictionID
		{
			get
			{
				return this._DeviceNotifictionID;
			}
			set
			{
				if ((this._DeviceNotifictionID != value))
				{
					this.OnDeviceNotifictionIDChanging(value);
					this.SendPropertyChanging();
					this._DeviceNotifictionID = value;
					this.SendPropertyChanged("DeviceNotifictionID");
					this.OnDeviceNotifictionIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceIP", DbType="NVarChar(300)")]
		public string DeviceIP
		{
			get
			{
				return this._DeviceIP;
			}
			set
			{
				if ((this._DeviceIP != value))
				{
					this.OnDeviceIPChanging(value);
					this.SendPropertyChanging();
					this._DeviceIP = value;
					this.SendPropertyChanged("DeviceIP");
					this.OnDeviceIPChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceBrand", DbType="NVarChar(100)")]
		public string DeviceBrand
		{
			get
			{
				return this._DeviceBrand;
			}
			set
			{
				if ((this._DeviceBrand != value))
				{
					this.OnDeviceBrandChanging(value);
					this.SendPropertyChanging();
					this._DeviceBrand = value;
					this.SendPropertyChanged("DeviceBrand");
					this.OnDeviceBrandChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceModel", DbType="NVarChar(100)")]
		public string DeviceModel
		{
			get
			{
				return this._DeviceModel;
			}
			set
			{
				if ((this._DeviceModel != value))
				{
					this.OnDeviceModelChanging(value);
					this.SendPropertyChanging();
					this._DeviceModel = value;
					this.SendPropertyChanged("DeviceModel");
					this.OnDeviceModelChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceOsVersion", DbType="NVarChar(100)")]
		public string DeviceOsVersion
		{
			get
			{
				return this._DeviceOsVersion;
			}
			set
			{
				if ((this._DeviceOsVersion != value))
				{
					this.OnDeviceOsVersionChanging(value);
					this.SendPropertyChanging();
					this._DeviceOsVersion = value;
					this.SendPropertyChanged("DeviceOsVersion");
					this.OnDeviceOsVersionChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceScreenSize", DbType="NVarChar(100)")]
		public string DeviceScreenSize
		{
			get
			{
				return this._DeviceScreenSize;
			}
			set
			{
				if ((this._DeviceScreenSize != value))
				{
					this.OnDeviceScreenSizeChanging(value);
					this.SendPropertyChanging();
					this._DeviceScreenSize = value;
					this.SendPropertyChanged("DeviceScreenSize");
					this.OnDeviceScreenSizeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceStatusID", DbType="Int")]
		public System.Nullable<int> DeviceStatusID
		{
			get
			{
				return this._DeviceStatusID;
			}
			set
			{
				if ((this._DeviceStatusID != value))
				{
					this.OnDeviceStatusIDChanging(value);
					this.SendPropertyChanging();
					this._DeviceStatusID = value;
					this.SendPropertyChanged("DeviceStatusID");
					this.OnDeviceStatusIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_DeviceAppVersion", DbType="NVarChar(20)")]
		public string DeviceAppVersion
		{
			get
			{
				return this._DeviceAppVersion;
			}
			set
			{
				if ((this._DeviceAppVersion != value))
				{
					this.OnDeviceAppVersionChanging(value);
					this.SendPropertyChanging();
					this._DeviceAppVersion = value;
					this.SendPropertyChanged("DeviceAppVersion");
					this.OnDeviceAppVersionChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime NOT NULL")]
		public System.DateTime RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this.OnRegDateChanging(value);
					this.SendPropertyChanging();
					this._RegDate = value;
					this.SendPropertyChanged("RegDate");
					this.OnRegDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblUser_tblUser_Device", Storage="_tblUser", ThisKey="UserID", OtherKey="ID", IsForeignKey=true)]
		public tblUser tblUser
		{
			get
			{
				return this._tblUser.Entity;
			}
			set
			{
				tblUser previousValue = this._tblUser.Entity;
				if (((previousValue != value) 
							|| (this._tblUser.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblUser.Entity = null;
						previousValue.tblUser_Devices.Remove(this);
					}
					this._tblUser.Entity = value;
					if ((value != null))
					{
						value.tblUser_Devices.Add(this);
						this._UserID = value.ID;
					}
					else
					{
						this._UserID = default(Nullable<System.Guid>);
					}
					this.SendPropertyChanged("tblUser");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="[1607_sqladmin].vwBrandsByCat")]
	public partial class vwBrandsByCat
	{
		
		private System.Nullable<int> _ID;
		
		private string _BrandName_FA;
		
		private string _BrandName_EN;
		
		private string _BrandImage;
		
		private System.Nullable<int> _BrandPriority;
		
		private System.Nullable<short> _BrandIsActive;
		
		private int _CatID;
		
		public vwBrandsByCat()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="Int")]
		public System.Nullable<int> ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this._ID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandName_FA", DbType="NVarChar(400)")]
		public string BrandName_FA
		{
			get
			{
				return this._BrandName_FA;
			}
			set
			{
				if ((this._BrandName_FA != value))
				{
					this._BrandName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandName_EN", DbType="NVarChar(400)")]
		public string BrandName_EN
		{
			get
			{
				return this._BrandName_EN;
			}
			set
			{
				if ((this._BrandName_EN != value))
				{
					this._BrandName_EN = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandImage", DbType="NVarChar(400)")]
		public string BrandImage
		{
			get
			{
				return this._BrandImage;
			}
			set
			{
				if ((this._BrandImage != value))
				{
					this._BrandImage = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandPriority", DbType="Int")]
		public System.Nullable<int> BrandPriority
		{
			get
			{
				return this._BrandPriority;
			}
			set
			{
				if ((this._BrandPriority != value))
				{
					this._BrandPriority = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandIsActive", DbType="SmallInt")]
		public System.Nullable<short> BrandIsActive
		{
			get
			{
				return this._BrandIsActive;
			}
			set
			{
				if ((this._BrandIsActive != value))
				{
					this._BrandIsActive = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CatID", DbType="Int NOT NULL")]
		public int CatID
		{
			get
			{
				return this._CatID;
			}
			set
			{
				if ((this._CatID != value))
				{
					this._CatID = value;
				}
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.wvSubCategories")]
	public partial class wvSubCategory
	{
		
		private int _ID;
		
		private int _CategoryID;
		
		private string _SubCategoryName_FA;
		
		private string _SubCategoryName_EN;
		
		private System.Nullable<int> _SubCategoryPriority;
		
		private System.Nullable<System.DateTime> _RegDate;
		
		private string _CategoryName_FA;
		
		public wvSubCategory()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="Int NOT NULL")]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this._ID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryID", DbType="Int NOT NULL")]
		public int CategoryID
		{
			get
			{
				return this._CategoryID;
			}
			set
			{
				if ((this._CategoryID != value))
				{
					this._CategoryID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryName_FA", DbType="NVarChar(200) NOT NULL", CanBeNull=false)]
		public string SubCategoryName_FA
		{
			get
			{
				return this._SubCategoryName_FA;
			}
			set
			{
				if ((this._SubCategoryName_FA != value))
				{
					this._SubCategoryName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryName_EN", DbType="NVarChar(200)")]
		public string SubCategoryName_EN
		{
			get
			{
				return this._SubCategoryName_EN;
			}
			set
			{
				if ((this._SubCategoryName_EN != value))
				{
					this._SubCategoryName_EN = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryPriority", DbType="Int")]
		public System.Nullable<int> SubCategoryPriority
		{
			get
			{
				return this._SubCategoryPriority;
			}
			set
			{
				if ((this._SubCategoryPriority != value))
				{
					this._SubCategoryPriority = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this._RegDate = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryName_FA", DbType="NVarChar(200)")]
		public string CategoryName_FA
		{
			get
			{
				return this._CategoryName_FA;
			}
			set
			{
				if ((this._CategoryName_FA != value))
				{
					this._CategoryName_FA = value;
				}
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.vwProducts")]
	public partial class vwProduct
	{
		
		private string _CategoryName_FA;
		
		private string _SubCategoryName_FA;
		
		private string _BrandName_FA;
		
		private string _GenderTitle;
		
		private int _ID;
		
		private int _SubCategoryID;
		
		private string _ProductCode;
		
		private string _ProductName_FA;
		
		private string _ProductName_EN;
		
		private string _ProductDesc;
		
		private short _ProductGender;
		
		private int _BrandID;
		
		private string _ProductMainImage;
		
		private string _Product3DImage;
		
		private System.Nullable<int> _ProductPriority;
		
		private System.Nullable<System.DateTime> _RegDate;
		
		private System.Nullable<int> _GenderID;
		
		private string _LastPrice;
		
		public vwProduct()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryName_FA", DbType="NVarChar(200)")]
		public string CategoryName_FA
		{
			get
			{
				return this._CategoryName_FA;
			}
			set
			{
				if ((this._CategoryName_FA != value))
				{
					this._CategoryName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryName_FA", DbType="NVarChar(200)")]
		public string SubCategoryName_FA
		{
			get
			{
				return this._SubCategoryName_FA;
			}
			set
			{
				if ((this._SubCategoryName_FA != value))
				{
					this._SubCategoryName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandName_FA", DbType="NVarChar(400)")]
		public string BrandName_FA
		{
			get
			{
				return this._BrandName_FA;
			}
			set
			{
				if ((this._BrandName_FA != value))
				{
					this._BrandName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_GenderTitle", DbType="NVarChar(100)")]
		public string GenderTitle
		{
			get
			{
				return this._GenderTitle;
			}
			set
			{
				if ((this._GenderTitle != value))
				{
					this._GenderTitle = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="Int NOT NULL")]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this._ID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryID", DbType="Int NOT NULL")]
		public int SubCategoryID
		{
			get
			{
				return this._SubCategoryID;
			}
			set
			{
				if ((this._SubCategoryID != value))
				{
					this._SubCategoryID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductCode", DbType="NVarChar(40) NOT NULL", CanBeNull=false)]
		public string ProductCode
		{
			get
			{
				return this._ProductCode;
			}
			set
			{
				if ((this._ProductCode != value))
				{
					this._ProductCode = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductName_FA", DbType="NVarChar(400) NOT NULL", CanBeNull=false)]
		public string ProductName_FA
		{
			get
			{
				return this._ProductName_FA;
			}
			set
			{
				if ((this._ProductName_FA != value))
				{
					this._ProductName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductName_EN", DbType="NVarChar(400)")]
		public string ProductName_EN
		{
			get
			{
				return this._ProductName_EN;
			}
			set
			{
				if ((this._ProductName_EN != value))
				{
					this._ProductName_EN = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductDesc", DbType="NText", UpdateCheck=UpdateCheck.Never)]
		public string ProductDesc
		{
			get
			{
				return this._ProductDesc;
			}
			set
			{
				if ((this._ProductDesc != value))
				{
					this._ProductDesc = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductGender", DbType="SmallInt NOT NULL")]
		public short ProductGender
		{
			get
			{
				return this._ProductGender;
			}
			set
			{
				if ((this._ProductGender != value))
				{
					this._ProductGender = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandID", DbType="Int NOT NULL")]
		public int BrandID
		{
			get
			{
				return this._BrandID;
			}
			set
			{
				if ((this._BrandID != value))
				{
					this._BrandID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductMainImage", DbType="NVarChar(300)")]
		public string ProductMainImage
		{
			get
			{
				return this._ProductMainImage;
			}
			set
			{
				if ((this._ProductMainImage != value))
				{
					this._ProductMainImage = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Product3DImage", DbType="NVarChar(300)")]
		public string Product3DImage
		{
			get
			{
				return this._Product3DImage;
			}
			set
			{
				if ((this._Product3DImage != value))
				{
					this._Product3DImage = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductPriority", DbType="Int")]
		public System.Nullable<int> ProductPriority
		{
			get
			{
				return this._ProductPriority;
			}
			set
			{
				if ((this._ProductPriority != value))
				{
					this._ProductPriority = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this._RegDate = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_GenderID", DbType="Int")]
		public System.Nullable<int> GenderID
		{
			get
			{
				return this._GenderID;
			}
			set
			{
				if ((this._GenderID != value))
				{
					this._GenderID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_LastPrice", DbType="NChar(20)")]
		public string LastPrice
		{
			get
			{
				return this._LastPrice;
			}
			set
			{
				if ((this._LastPrice != value))
				{
					this._LastPrice = value;
				}
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.vwProductsCats")]
	public partial class vwProductsCat
	{
		
		private System.Nullable<int> _ID;
		
		private string _CategoryName_FA;
		
		private string _CategoryName_EN;
		
		private System.Nullable<int> _CategoryPriority;
		
		private System.Nullable<System.DateTime> _RegDate;
		
		private System.Nullable<int> _GenderID;
		
		public vwProductsCat()
		{
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", DbType="Int")]
		public System.Nullable<int> ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this._ID = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryName_FA", DbType="NVarChar(200)")]
		public string CategoryName_FA
		{
			get
			{
				return this._CategoryName_FA;
			}
			set
			{
				if ((this._CategoryName_FA != value))
				{
					this._CategoryName_FA = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryName_EN", DbType="NVarChar(200)")]
		public string CategoryName_EN
		{
			get
			{
				return this._CategoryName_EN;
			}
			set
			{
				if ((this._CategoryName_EN != value))
				{
					this._CategoryName_EN = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_CategoryPriority", DbType="Int")]
		public System.Nullable<int> CategoryPriority
		{
			get
			{
				return this._CategoryPriority;
			}
			set
			{
				if ((this._CategoryPriority != value))
				{
					this._CategoryPriority = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this._RegDate = value;
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_GenderID", DbType="Int")]
		public System.Nullable<int> GenderID
		{
			get
			{
				return this._GenderID;
			}
			set
			{
				if ((this._GenderID != value))
				{
					this._GenderID = value;
				}
			}
		}
	}
	
	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.tblProducts")]
	public partial class tblProduct : INotifyPropertyChanging, INotifyPropertyChanged
	{
		
		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
		
		private int _ID;
		
		private int _BrandID;
		
		private int _SubCategoryID;
		
		private short _ProductGender;
		
		private string _ProductCode;
		
		private string _ProductName_FA;
		
		private string _ProductName_EN;
		
		private string _ProductDesc;
		
		private string _LastPrice;
		
		private string _ProductMainImage;
		
		private string _Product3DImage;
		
		private System.Nullable<int> _ProductPriority;
		
		private System.Nullable<System.DateTime> _RegDate;
		
		private EntitySet<tblProduct_price> _tblProduct_prices;
		
		private EntitySet<tblProducts_Gender> _tblProducts_Genders;
		
		private EntityRef<tblBrand> _tblBrand;
		
		private EntityRef<tblProduct_SubCategory> _tblProduct_SubCategory;
		
    #region Extensibility Method Definitions
    partial void OnLoaded();
    partial void OnValidate(System.Data.Linq.ChangeAction action);
    partial void OnCreated();
    partial void OnIDChanging(int value);
    partial void OnIDChanged();
    partial void OnBrandIDChanging(int value);
    partial void OnBrandIDChanged();
    partial void OnSubCategoryIDChanging(int value);
    partial void OnSubCategoryIDChanged();
    partial void OnProductGenderChanging(short value);
    partial void OnProductGenderChanged();
    partial void OnProductCodeChanging(string value);
    partial void OnProductCodeChanged();
    partial void OnProductName_FAChanging(string value);
    partial void OnProductName_FAChanged();
    partial void OnProductName_ENChanging(string value);
    partial void OnProductName_ENChanged();
    partial void OnProductDescChanging(string value);
    partial void OnProductDescChanged();
    partial void OnLastPriceChanging(string value);
    partial void OnLastPriceChanged();
    partial void OnProductMainImageChanging(string value);
    partial void OnProductMainImageChanged();
    partial void OnProduct3DImageChanging(string value);
    partial void OnProduct3DImageChanged();
    partial void OnProductPriorityChanging(System.Nullable<int> value);
    partial void OnProductPriorityChanged();
    partial void OnRegDateChanging(System.Nullable<System.DateTime> value);
    partial void OnRegDateChanged();
    #endregion
		
		public tblProduct()
		{
			this._tblProduct_prices = new EntitySet<tblProduct_price>(new Action<tblProduct_price>(this.attach_tblProduct_prices), new Action<tblProduct_price>(this.detach_tblProduct_prices));
			this._tblProducts_Genders = new EntitySet<tblProducts_Gender>(new Action<tblProducts_Gender>(this.attach_tblProducts_Genders), new Action<tblProducts_Gender>(this.detach_tblProducts_Genders));
			this._tblBrand = default(EntityRef<tblBrand>);
			this._tblProduct_SubCategory = default(EntityRef<tblProduct_SubCategory>);
			OnCreated();
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ID", AutoSync=AutoSync.OnInsert, DbType="Int NOT NULL IDENTITY", IsPrimaryKey=true, IsDbGenerated=true)]
		public int ID
		{
			get
			{
				return this._ID;
			}
			set
			{
				if ((this._ID != value))
				{
					this.OnIDChanging(value);
					this.SendPropertyChanging();
					this._ID = value;
					this.SendPropertyChanged("ID");
					this.OnIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_BrandID", DbType="Int NOT NULL")]
		public int BrandID
		{
			get
			{
				return this._BrandID;
			}
			set
			{
				if ((this._BrandID != value))
				{
					if (this._tblBrand.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnBrandIDChanging(value);
					this.SendPropertyChanging();
					this._BrandID = value;
					this.SendPropertyChanged("BrandID");
					this.OnBrandIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_SubCategoryID", DbType="Int NOT NULL")]
		public int SubCategoryID
		{
			get
			{
				return this._SubCategoryID;
			}
			set
			{
				if ((this._SubCategoryID != value))
				{
					if (this._tblProduct_SubCategory.HasLoadedOrAssignedValue)
					{
						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
					}
					this.OnSubCategoryIDChanging(value);
					this.SendPropertyChanging();
					this._SubCategoryID = value;
					this.SendPropertyChanged("SubCategoryID");
					this.OnSubCategoryIDChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductGender", DbType="SmallInt NOT NULL")]
		public short ProductGender
		{
			get
			{
				return this._ProductGender;
			}
			set
			{
				if ((this._ProductGender != value))
				{
					this.OnProductGenderChanging(value);
					this.SendPropertyChanging();
					this._ProductGender = value;
					this.SendPropertyChanged("ProductGender");
					this.OnProductGenderChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductCode", DbType="NVarChar(40) NOT NULL", CanBeNull=false)]
		public string ProductCode
		{
			get
			{
				return this._ProductCode;
			}
			set
			{
				if ((this._ProductCode != value))
				{
					this.OnProductCodeChanging(value);
					this.SendPropertyChanging();
					this._ProductCode = value;
					this.SendPropertyChanged("ProductCode");
					this.OnProductCodeChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductName_FA", DbType="NVarChar(400) NOT NULL", CanBeNull=false)]
		public string ProductName_FA
		{
			get
			{
				return this._ProductName_FA;
			}
			set
			{
				if ((this._ProductName_FA != value))
				{
					this.OnProductName_FAChanging(value);
					this.SendPropertyChanging();
					this._ProductName_FA = value;
					this.SendPropertyChanged("ProductName_FA");
					this.OnProductName_FAChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductName_EN", DbType="NVarChar(400)")]
		public string ProductName_EN
		{
			get
			{
				return this._ProductName_EN;
			}
			set
			{
				if ((this._ProductName_EN != value))
				{
					this.OnProductName_ENChanging(value);
					this.SendPropertyChanging();
					this._ProductName_EN = value;
					this.SendPropertyChanged("ProductName_EN");
					this.OnProductName_ENChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductDesc", DbType="NText", UpdateCheck=UpdateCheck.Never)]
		public string ProductDesc
		{
			get
			{
				return this._ProductDesc;
			}
			set
			{
				if ((this._ProductDesc != value))
				{
					this.OnProductDescChanging(value);
					this.SendPropertyChanging();
					this._ProductDesc = value;
					this.SendPropertyChanged("ProductDesc");
					this.OnProductDescChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_LastPrice", DbType="NChar(20)")]
		public string LastPrice
		{
			get
			{
				return this._LastPrice;
			}
			set
			{
				if ((this._LastPrice != value))
				{
					this.OnLastPriceChanging(value);
					this.SendPropertyChanging();
					this._LastPrice = value;
					this.SendPropertyChanged("LastPrice");
					this.OnLastPriceChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductMainImage", DbType="NVarChar(300)")]
		public string ProductMainImage
		{
			get
			{
				return this._ProductMainImage;
			}
			set
			{
				if ((this._ProductMainImage != value))
				{
					this.OnProductMainImageChanging(value);
					this.SendPropertyChanging();
					this._ProductMainImage = value;
					this.SendPropertyChanged("ProductMainImage");
					this.OnProductMainImageChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Product3DImage", DbType="NVarChar(300)")]
		public string Product3DImage
		{
			get
			{
				return this._Product3DImage;
			}
			set
			{
				if ((this._Product3DImage != value))
				{
					this.OnProduct3DImageChanging(value);
					this.SendPropertyChanging();
					this._Product3DImage = value;
					this.SendPropertyChanged("Product3DImage");
					this.OnProduct3DImageChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ProductPriority", DbType="Int")]
		public System.Nullable<int> ProductPriority
		{
			get
			{
				return this._ProductPriority;
			}
			set
			{
				if ((this._ProductPriority != value))
				{
					this.OnProductPriorityChanging(value);
					this.SendPropertyChanging();
					this._ProductPriority = value;
					this.SendPropertyChanged("ProductPriority");
					this.OnProductPriorityChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_RegDate", DbType="DateTime")]
		public System.Nullable<System.DateTime> RegDate
		{
			get
			{
				return this._RegDate;
			}
			set
			{
				if ((this._RegDate != value))
				{
					this.OnRegDateChanging(value);
					this.SendPropertyChanging();
					this._RegDate = value;
					this.SendPropertyChanged("RegDate");
					this.OnRegDateChanged();
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_tblProduct_price", Storage="_tblProduct_prices", ThisKey="ID", OtherKey="ProductID")]
		public EntitySet<tblProduct_price> tblProduct_prices
		{
			get
			{
				return this._tblProduct_prices;
			}
			set
			{
				this._tblProduct_prices.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_tblProducts_Gender", Storage="_tblProducts_Genders", ThisKey="ID", OtherKey="ProductID")]
		public EntitySet<tblProducts_Gender> tblProducts_Genders
		{
			get
			{
				return this._tblProducts_Genders;
			}
			set
			{
				this._tblProducts_Genders.Assign(value);
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblBrand_tblProduct", Storage="_tblBrand", ThisKey="BrandID", OtherKey="ID", IsForeignKey=true)]
		public tblBrand tblBrand
		{
			get
			{
				return this._tblBrand.Entity;
			}
			set
			{
				tblBrand previousValue = this._tblBrand.Entity;
				if (((previousValue != value) 
							|| (this._tblBrand.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblBrand.Entity = null;
						previousValue.tblProducts.Remove(this);
					}
					this._tblBrand.Entity = value;
					if ((value != null))
					{
						value.tblProducts.Add(this);
						this._BrandID = value.ID;
					}
					else
					{
						this._BrandID = default(int);
					}
					this.SendPropertyChanged("tblBrand");
				}
			}
		}
		
		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="tblProduct_SubCategory_tblProduct", Storage="_tblProduct_SubCategory", ThisKey="SubCategoryID", OtherKey="ID", IsForeignKey=true)]
		public tblProduct_SubCategory tblProduct_SubCategory
		{
			get
			{
				return this._tblProduct_SubCategory.Entity;
			}
			set
			{
				tblProduct_SubCategory previousValue = this._tblProduct_SubCategory.Entity;
				if (((previousValue != value) 
							|| (this._tblProduct_SubCategory.HasLoadedOrAssignedValue == false)))
				{
					this.SendPropertyChanging();
					if ((previousValue != null))
					{
						this._tblProduct_SubCategory.Entity = null;
						previousValue.tblProducts.Remove(this);
					}
					this._tblProduct_SubCategory.Entity = value;
					if ((value != null))
					{
						value.tblProducts.Add(this);
						this._SubCategoryID = value.ID;
					}
					else
					{
						this._SubCategoryID = default(int);
					}
					this.SendPropertyChanged("tblProduct_SubCategory");
				}
			}
		}
		
		public event PropertyChangingEventHandler PropertyChanging;
		
		public event PropertyChangedEventHandler PropertyChanged;
		
		protected virtual void SendPropertyChanging()
		{
			if ((this.PropertyChanging != null))
			{
				this.PropertyChanging(this, emptyChangingEventArgs);
			}
		}
		
		protected virtual void SendPropertyChanged(String propertyName)
		{
			if ((this.PropertyChanged != null))
			{
				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
		
		private void attach_tblProduct_prices(tblProduct_price entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct = this;
		}
		
		private void detach_tblProduct_prices(tblProduct_price entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct = null;
		}
		
		private void attach_tblProducts_Genders(tblProducts_Gender entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct = this;
		}
		
		private void detach_tblProducts_Genders(tblProducts_Gender entity)
		{
			this.SendPropertyChanging();
			entity.tblProduct = null;
		}
	}
}
#pragma warning restore 1591
